## votca 2023

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(votca LANGUAGES CXX)

set(PROJECT_VERSION "2023")
string(REGEX REPLACE "[-.].*$" "" SOVERSION "${PROJECT_VERSION}")
if (NOT ${SOVERSION} MATCHES "^[0-9]+$")
  message(FATAL_ERROR "Could not determine SOVERSION (${SOVERSION}) from ${PROJECT_VERSION}")
endif (NOT ${SOVERSION} MATCHES "^[0-9]+$")
set(PROJECT_CONTACT "https://github.com/votca/votca/issues")

# Cmake modules/macros are in a subdirectory to keep this file cleaner
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
  #release comes with -O3 by default
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)

include(GNUInstallDirs)
include(FeatureSummary)
include(CheckCXXCompilerFlag)

########################################################################
# User input options                                                   #
########################################################################
option(BUILD_XTP "Build xtp" OFF)
add_feature_info(BUILD_XTP BUILD_XTP "Build xtp module")

option(ENABLE_COVERAGE_BUILD "Do a coverage build" OFF)
if(ENABLE_COVERAGE_BUILD)
    message(STATUS "Enabling coverage build")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
    # in coverage mode, so tests will take very long
    set(DART_TESTING_TIMEOUT 7200 CACHE STRING "Maximum time allowed before CTest will kill the test.")
endif()

include(CTest)
option(BUILD_TESTING "Build and copy testing stuff" ON)
add_feature_info(BUILD_TESTING BUILD_TESTING "Enable unit tests")
if(BUILD_TESTING)
  find_package(Boost 1.71.0 REQUIRED COMPONENTS unit_test_framework)
endif()

option(BUILD_SHARED_LIBS "Build shared libs" ON)

option(ENABLE_RPATH_INJECT "Inject link and install libdir into executables" OFF)
add_feature_info(ENABLE_RPATH_INJECT ENABLE_RPATH_INJECT "Inject rpath into executables")
if(ENABLE_RPATH_INJECT)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH ON)
  set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
endif(ENABLE_RPATH_INJECT)

option(ENABLE_WARNING_FLAGS "Inject more warning flags" ON)
if(ENABLE_WARNING_FLAGS)
  foreach(_FLAG -Wall -Wextra -Wpedantic -Wshadow -Wconversion) 
    check_cxx_compiler_flag("${_FLAG}" COMPILER_SUPPORTS${_FLAG})
    if(COMPILER_SUPPORTS${_FLAG})
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_FLAG}")
    endif()
  endforeach()
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-conversion")
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "Intel") #only icpc, not icpx
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcheck -Wno-sign-conversion")
  endif()
  # allow adding extra warning flags at the very end
  if(VOTCA_EXTRA_WARNING_FLAGS)
    message(STATUS "Adding extra flags: ${VOTCA_EXTRA_WARNING_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${VOTCA_EXTRA_WARNING_FLAGS}")
  endif()
endif()

option(INJECT_MARCH_NATIVE "Inject -march=native if compiler supports it" ON)
add_feature_info(INJECT_MARCH_NATIVE INJECT_MARCH_NATIVE "Add -march=native to CXX flags")
if(INJECT_MARCH_NATIVE)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-march=native" COMPILER_SUPPORTS_march_native)
  if(COMPILER_SUPPORTS_march_native)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
  endif()
endif()

option(ENABLE_WERROR "Inject -Werror" OFF)
if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(CMAKE_CXX_COMPILER MATCHES "dpcpp")
  message(WARNING "Using the intel dpcpp compiler needs a cutting-edge version of eigen hence dpcpp is currently not offically supported, use icpx instead") 
endif()

option(INSTALL_RC_FILES "Install votca rc files, no need when installing under /usr" ON)
add_feature_info(INSTALL_RC_FILES INSTALL_RC_FILES "Install votca rc files (VOTCARC.bash etc.)")

########################################################################
#Find external packages
########################################################################
find_package(Boost 1.71.0 REQUIRED
  COMPONENTS program_options filesystem system regex timer)
set_package_properties(Boost PROPERTIES TYPE REQUIRED PURPOSE "Extended C++ libraries")

find_package(Eigen3 3.3.0 NO_MODULE REQUIRED)
set_package_properties(Eigen3 PROPERTIES TYPE REQUIRED PURPOSE "C++ vector data structures")
message(STATUS "Found Eigen3: ${Eigen3_DIR}")

find_package(Threads REQUIRED)
set_package_properties(Threads PROPERTIES TYPE REQUIRED PURPOSE "Used for thread parallelization")

option(BUILD_OWN_GROMACS "Build our own gromacs" OFF)
add_feature_info( BUILD_OWN_GROMACS BUILD_OWN_GROMACS "Build an internal version of gromacs")
if(BUILD_OWN_GROMACS)
  include(${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/BuildGromacs.cmake)
else()
  find_package(GROMACS 2019.6 CONFIG NAMES gromacs gromacs_d)
  set_package_properties(GROMACS PROPERTIES TYPE RECOMMENDED PURPOSE "Used to read/write gromacs data files")
  if(GROMACS_FOUND AND DEFINED GROMACS_VERSION AND GROMACS_VERSION VERSION_GREATER_EQUAL "2020")
    message(WARNING "Gromacs-2020 and above have no support for tabulated interactions, that are needed for coarse-graining (see and comment on https://gitlab.com/gromacs/gromacs/-/issues/1347)")
  endif()
  # prior gmx-2021, their exported target had some bugs, that we fix below
  # - missing GMX_DOUBLE define - only gets exported as GROMACS_DEFINITIONS
  # - missing include directory
  # - missing namespace
  if(GROMACS_FOUND AND DEFINED GROMACS_VERSION AND GROMACS_VERSION VERSION_LESS "2021")
    set_target_properties(libgromacs PROPERTIES
      INTERFACE_COMPILE_OPTIONS ${GROMACS_DEFINITIONS} INTERFACE_INCLUDE_DIRECTORIES ${GROMACS_INCLUDE_DIRS})
    add_library(Gromacs::libgromacs ALIAS libgromacs)
  endif()
  if(GROMACS_FOUND AND DEFINED GROMACS_VERSION)
    find_path(_GROMACS_VERSION_PATH gromacs/version.h HINTS ${GROMACS_INCLUDE_DIRS})
    if(NOT _GROMACS_VERSION_PATH)
      message(FATAL_ERROR "Gromacs library was found, but its headers were not. Make sure you have installed the gromacs-devel package or built gromacs with -DGMX_INSTALL_LEGACY_API=ON")
    endif()
  endif()
endif()

# iie methods needs python 3.5+
find_package(Python 3.5 REQUIRED COMPONENTS Interpreter)
set_package_properties(Python PROPERTIES TYPE OPTIONAL PURPOSE "Used in csg scripts and docu")
option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" ${Python_FOUND})
add_feature_info(BUILD_MANPAGES BUILD_MANPAGES "Build manpages (disable for cross-compile)")
if(BUILD_MANPAGES)
  #define this target here, so that individual man pages can append to it.
  add_custom_target(manpages ALL)
endif()

set(MATH_LIBRARIES "m" CACHE STRING "math library")
mark_as_advanced( MATH_LIBRARIES )

if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Generated version for development version")
endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)

find_package(SPHINX)
if(SPHINX_FOUND)
  #define this target here, so that individual rst generation target can append to it.
  add_custom_target(sphinx-deps)
  set(VOTCA_SPHINX_DIR "${PROJECT_BINARY_DIR}/sphinx" CACHE INTERNAL "Path for Sphinx sources")
  file(MAKE_DIRECTORY ${VOTCA_SPHINX_DIR})
  set(VOTCA_SPHINX_OUTPUT_DIR "${PROJECT_BINARY_DIR}/sphinx.html" CACHE PATH "Path for Sphinx output")
endif()

option(BUILD_OWN_LIBINT "Build our own lib" OFF)
add_feature_info(BUILD_OWN_LIBINT BUILD_OWN_LIBINT "Build an internal version of libint")
if(BUILD_OWN_LIBINT)
  include(${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/BuildLibint.cmake)
endif()
######################################
# Include the following subdirectory # 
######################################
configure_file(${PROJECT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

add_subdirectory(tools)
add_subdirectory(csg)
add_subdirectory(csg-tutorials)
if(BUILD_XTP)
  add_subdirectory(xtp)
  add_subdirectory(xtp-tutorials)
endif()

add_subdirectory(share/sphinx)
add_subdirectory(share/doxygen)
add_subdirectory(share/format)

feature_summary(INCLUDE_QUIET_PACKAGES WHAT ALL)

=== tools/CMakeLists.txt ===
########################################################################
# Checks what linear algebra packages are installed                    #
########################################################################

# Eigen does not support the ilp64 interface right now, see https://gitlab.com/libeigen/eigen/-/issues/2586
set(MKL_INTERFACE "lp64")
find_package(MKL CONFIG)
set_package_properties(MKL PROPERTIES TYPE OPTIONAL PURPOSE "Enables accelerated performance with MKL")
# Replace the below with CMAKE_REQUIRE_FIND_PACKAGE_MKL, when we switch to
# CMake-3.22+
option(REQUIRE_MKL "Require MKL" OFF)
if(REQUIRE_MKL)
  find_package(MKL REQUIRED)
endif()

#user defined reductions are buggy for <= clang-9 (see https://bugs.llvm.org/show_bug.cgi?id=44134)
if (CMAKE_CXX_COMPILER MATCHES "clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10.0)
  # in case OpenMP was detected somewhere else
  unset(OpenMP_FOUND)
else()
  find_package(OpenMP 4.5)
  set_package_properties(OpenMP PROPERTIES TYPE RECOMMENDED PURPOSE "Used for thread parallelization in tools")
endif()

if(MKL_FOUND)
  # MKL has its internal fftw3 implementation
  unset(FFTW3_FOUND)
else()
  find_package(FFTW3)
  set_package_properties(FFTW3 PROPERTIES TYPE RECOMMENDED PURPOSE "Enables FFT functionality")
endif()

########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFileCXX)
foreach(HEADER cassert cmath fstream functional iostream limits list map ostream sstream stack stdexcept string vector)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

######################################
# Include the following subdirectory #
######################################
add_subdirectory(scripts)
add_subdirectory(src)
add_subdirectory(include/votca/tools)
add_subdirectory(share/man)

=== xtp-tutorials/CMakeLists.txt ===
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/xtp-tutorials USE_SOURCE_PERMISSIONS
	PATTERN ".git*" EXCLUDE
	PATTERN "CMake*" EXCLUDE PATTERN "cmake_install.cmake" EXCLUDE
	PATTERN "install_manifest.txt" EXCLUDE PATTERN "*~" EXCLUDE)

add_subdirectory(share/doc)

=== xtp/CMakeLists.txt ===
########################################################################
# User input options                                                   #
########################################################################
find_package(Libxc QUIET CONFIG)
set_package_properties(Libxc PROPERTIES TYPE REQUIRED PURPOSE "Provides exchange-correclation functionals")
if(NOT Libxc_FOUND)
  find_package(Libxc MODULE REQUIRED)
endif()
if(NOT TARGET Libint2::int2)
  find_package(libint2 QUIET CONFIG)
  set_package_properties(libint2 PROPERTIES TYPE REQUIRED PURPOSE "Calculates Gaussian integrals")
  if(NOT libint2_FOUND)
    find_package(libint2 2.6 MODULE REQUIRED)
  endif()
endif()
find_package(ecpint REQUIRED)
set_package_properties(ecpint PROPERTIES TYPE REQUIRED PURPOSE "Calculates Gaussian integrals over pseudo potentials")
message(STATUS "Found libecpint: ${ecpint_DIR}")

find_package(HDF5 1.8 REQUIRED COMPONENTS CXX)
set_package_properties(HDF5 PROPERTIES TYPE REQUIRED PURPOSE "Used to read/write HDF5 data files")

if(HDF5_VERSION VERSION_GREATER 1.8)
  message(WARNING "HDF5 will be used such that it is compatible with version 1.8.")
endif()

# https://github.com/votca/xtp/issues/436, hdf5-1.10.4 generates a implicitly-declared operator warning
if(HDF5_VERSION VERSION_GREATER_EQUAL 1.10.4 AND HDF5_VERSION VERSION_LESS_EQUAL 1.10.6)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-Wno-deprecated-copy" COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
  if(COMPILER_SUPPORTS_WNO_DEPRECATED_COPY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-copy")
  endif()
endif()

option(USE_CUDA "Use a Nvidia GPU to speed up computations" OFF)
add_feature_info(USE_CUDA USE_CUDA "Use CUDA for GPU acceleration")
########################################################################
#Find external packages
########################################################################
if(USE_CUDA)
  find_package(CUDA REQUIRED)
  set_package_properties(CUDA PROPERTIES TYPE REQUIRED PURPOSE "Used for GPU acceleration")
endif(USE_CUDA)

########################################################################
# Checks what linear algebra packages are installed                    #
########################################################################



########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFileCXX)
foreach(HEADER algorithm)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

######################################
# Include the following subdirectory #
######################################
add_subdirectory(include/votca/xtp)
add_subdirectory(scripts)
add_subdirectory(src)
add_subdirectory(share)

=== csg/scripts/CMakeLists.txt ===
# env for manpage generation
set(VOTCASHARE "${PROJECT_SOURCE_DIR}/csg/share")
set(VOTCA_PATH "${CMAKE_CURRENT_SOURCE_DIR}:${PROJECT_BINARY_DIR}/csg/src/tools")
set(VOTCA_CSG_DEFAULTS "${PROJECT_BINARY_DIR}/csg/share/xml/csg_defaults.xml")

set(CSG_RST_FILES)
foreach(SCRIPT csg_call csg_inverse)
  configure_file(${SCRIPT} ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.in2 @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.install)
  add_custom_command(OUTPUT ${SCRIPT}.install COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.in2" -DOUTPUT="${SCRIPT}.install"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${PROJECT_SOURCE_DIR}" -P ${PROJECT_SOURCE_DIR}/CMakeModules/gitscript.cmake
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.in2 ${PROJECT_SOURCE_DIR}/CMakeModules/gitscript.cmake
    COMMENT "Generating ${SCRIPT}")
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT}.install)
  set_property(TARGET votca_csg APPEND PROPERTY BINARIES "${SCRIPT}")
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.install RENAME ${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
  add_executable(VOTCA::${SCRIPT} IMPORTED GLOBAL)
  # version string gets removed from man & rst, so we can use the source version
  set_property(TARGET VOTCA::${SCRIPT} PROPERTY IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT}")
  if (BUILD_MANPAGES)
    add_custom_command(OUTPUT ${SCRIPT}.man
      COMMAND ${CMAKE_COMMAND} -E env VOTCASHARE="${VOTCASHARE}" PATH="${VOTCA_PATH}:$ENV{PATH}" VOTCA_CSG_DEFAULTS="${VOTCA_CSG_DEFAULTS}"
        $<TARGET_FILE:VOTCA::votca_help2doc> --name $<TARGET_FILE:VOTCA::${SCRIPT}> --format groff --out ${SCRIPT}.man
      COMMENT "Building ${SCRIPT} manpage"
      DEPENDS VOTCA::votca_help2doc ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT})
    add_custom_target(${SCRIPT}_manpage DEPENDS ${SCRIPT}.man)
    add_dependencies(manpages ${SCRIPT}_manpage)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME ${SCRIPT}.1)
  endif()
  if(SPHINX_FOUND)
    add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/csg/${SCRIPT}.rst
      COMMAND ${CMAKE_COMMAND} -E env VOTCASHARE="${VOTCASHARE}" PATH="${VOTCA_PATH}:$ENV{PATH}" VOTCA_CSG_DEFAULTS="${VOTCA_CSG_DEFAULTS}"
	$<TARGET_FILE:VOTCA::votca_help2doc> --name $<TARGET_FILE:VOTCA::${SCRIPT}> --format rst --out ${VOTCA_SPHINX_DIR}/csg/${SCRIPT}.rst
      COMMENT "Building ${SCRIPT} rst doc"
      DEPENDS VOTCA::votca_help2doc ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT})
    list(APPEND CSG_RST_FILES ${VOTCA_SPHINX_DIR}/csg/${SCRIPT}.rst)
  endif()
endforeach(SCRIPT)

set_target_properties(VOTCA::csg_call PROPERTIES VOTCASHARE "${VOTCASHARE}")
set_target_properties(VOTCA::csg_call PROPERTIES VOTCA_PATH "${VOTCA_PATH}")
set_target_properties(VOTCA::csg_inverse PROPERTIES VOTCA_CSG_DEFAULTS "${VOTCA_CSG_DEFAULTS}")

get_property(VOTCA_BINARIES TARGET votca_csg PROPERTY BINARIES)
list(SORT VOTCA_BINARIES)
# for .bash we need a space separated list
list(JOIN VOTCA_BINARIES " " VOTCA_BINARIES)
configure_file(csg-completion.bash.in "${CMAKE_CURRENT_BINARY_DIR}/csg-completion.bash" @ONLY)
if(INSTALL_RC_FILES)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/csg-completion.bash DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/rc)
endif()

if(SPHINX_FOUND)
  #don't call "csg_call -l" as csg_call isn't ready at cmake time
  file(READ ${VOTCASHARE}/scripts/inverse/csg_table CSG_SCRIPTS)
  string(REGEX REPLACE "#[^\n]*\n" "" CSG_SCRIPTS "${CSG_SCRIPTS}") # remove comments
  string(REGEX REPLACE " +" " " CSG_SCRIPTS "${CSG_SCRIPTS}") # multi-space in single space
  string(REGEX REPLACE "\n" ";" CSG_SCRIPTS "${CSG_SCRIPTS}") # turn into list
  string(REGEX REPLACE "; *;" ";" CSG_SCRIPTS "${CSG_SCRIPTS}") # remove empty line

  set(CSG_TABLE "${VOTCA_SPHINX_DIR}/csg/csg_table.rst")
  file(WRITE ${CSG_TABLE} ".. list-table::\n   :header-rows: 1\n   :align: center\n\n")
  file(APPEND ${CSG_TABLE} "   * - Key1\n     - Key2\n     - Scriptname\n")
  file(MAKE_DIRECTORY "${VOTCA_SPHINX_DIR}/csg/scripts")
  set(CSG_SCRIPTS_LIST)
  foreach(_LINE ${CSG_SCRIPTS})
    separate_arguments(_LINE)
    list(GET _LINE 0 TAG1)
    file(APPEND ${CSG_TABLE} "   * - ${TAG1}\n")
    list(GET _LINE 1 TAG2)
    file(APPEND ${CSG_TABLE} "     - ${TAG2}\n")
    list(GET _LINE 2 SCRIPT)
    list(REMOVE_AT _LINE 0 1)
    list(JOIN _LINE " " _LINE)
    file(APPEND ${CSG_TABLE} "     - ${_LINE}\n")
    set(FULL_SCRIPT "${VOTCA_SPHINX_DIR}/csg/scripts/${SCRIPT}.rst")
    list(FIND CSG_RST_FILES ${FULL_SCRIPT} _alreadyThere)
    if(NOT _alreadyThere STREQUAL "-1")
      continue()
    endif()
    list(APPEND CSG_RST_FILES ${FULL_SCRIPT})
    string(REGEX REPLACE "." "^" UNDERLINE "${SCRIPT}")
    list(APPEND CSG_SCRIPTS_LIST "${SCRIPT}\n${UNDERLINE}\n\n.. include:: scripts/${SCRIPT}.rst\n\n")
    add_custom_command(OUTPUT ${FULL_SCRIPT}
      COMMAND ${CMAKE_COMMAND} -E env VOTCASHARE="${VOTCASHARE}" PATH="${VOTCA_PATH}:$ENV{PATH}" VOTCA_CSG_DEFAULTS="${VOTCA_CSG_DEFAULTS}"
      $<TARGET_FILE:VOTCA::votca_help2doc> --name "$<TARGET_FILE:VOTCA::csg_call> ${TAG1} ${TAG2}" --format rst --out ${FULL_SCRIPT}
      COMMENT "Building ${SCRIPT} rst doc (from ${TAG1} ${TAG2})"
      DEPENDS VOTCA::votca_help2doc ${VOTCASHARE}/scripts/inverse/${SCRIPT})
  endforeach(_LINE)
  list(SORT CSG_SCRIPTS_LIST)
  set(CSG_SCRIPTS_RST "${VOTCA_SPHINX_DIR}/csg/csg_scripts.rst")
  file(WRITE ${CSG_SCRIPTS_RST} "\n")
  foreach(_LINE ${CSG_SCRIPTS_LIST})
    file(APPEND ${CSG_SCRIPTS_RST} ${_LINE})
  endforeach()

  add_custom_target(csg-scripts-rst DEPENDS ${CSG_RST_FILES})
  add_dependencies(sphinx-deps csg-scripts-rst)
endif()

=== share/sphinx/CMakeLists.txt ===
if(NOT SPHINX_FOUND)
  return()
endif()

set(SPHINX_DEPS ${VOTCA_SPHINX_DIR}/conf.py)
file(GLOB PAGES *.rst)
file(GLOB IMAGES *.png)
configure_file(conf.py.in ${VOTCA_SPHINX_DIR}/conf.py @ONLY)
foreach(_DEP ${PAGES} ${IMAGES})
  get_filename_component(_FILE "${_DEP}" NAME)
  add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/${_FILE}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${_DEP} ${VOTCA_SPHINX_DIR}/${_FILE} DEPENDS ${_DEP}
  )
  list(APPEND SPHINX_DEPS ${VOTCA_SPHINX_DIR}/${_FILE})
endforeach()
file(COPY _themes DESTINATION ${VOTCA_SPHINX_DIR})
foreach(_MODULE tools csg csg-tutorials xtp xtp-tutorials)
  file(MAKE_DIRECTORY ${VOTCA_SPHINX_DIR}/${_MODULE})
  file(GLOB ${_MODULE}_FILES ${_MODULE}/*)
  add_custom_target(${_MODULE}_copy_rst
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/${_MODULE} ${VOTCA_SPHINX_DIR}/${_MODULE}
    DEPENDS ${${_MODULE}_FILES})
    add_dependencies(sphinx-deps ${_MODULE}_copy_rst)
endforeach()
add_custom_target(sphinx COMMAND ${SPHINX_EXECUTABLE} ${VOTCA_SPHINX_DIR} ${VOTCA_SPHINX_OUTPUT_DIR}
  DEPENDS ${SPHINX_DEPS})
add_dependencies(sphinx sphinx-deps)

=== xtp/scripts/CMakeLists.txt ===
set(XTP_RST_FILES)
set(XTP_SCRIPTS)
foreach(_pkg lxml h5py rdkit)
  if(NOT PY${_pkg}_FOUND)
    execute_process(COMMAND ${Python_EXECUTABLE} -c "import ${_pkg}" RESULT_VARIABLE IMPORT_py${_pkg})
    if(IMPORT_py${_pkg} EQUAL 0)
      set(PY${_pkg}_FOUND TRUE CACHE INTERNAL "")
      message(STATUS "Found python module ${_pkg}")
    endif()
  endif()
endforeach()
if(PYlxml_FOUND)
  list(APPEND XTP_SCRIPTS xtp_basisset xtp_update_mapfile xtp_modify_jobfile)
endif()
if(PYrdkit_FOUND)
  list(APPEND XTP_SCRIPTS xtp_autogen_mapping)
endif()
if(PYh5py_FOUND)
  list(APPEND XTP_SCRIPTS xtp_qmmm2qm)
endif()

if(SPHINX_FOUND)
  set(XTP_REFERENCE "${VOTCA_SPHINX_DIR}/xtp/reference.rst")
  file(WRITE ${XTP_REFERENCE} "Reference\n=========\n\nPrograms\n--------\n\n")
endif()

foreach(SCRIPT ${XTP_SCRIPTS}) 
  configure_file(${SCRIPT} ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.in2 @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.install)
  add_custom_command(OUTPUT ${SCRIPT}.install COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.in2" -DOUTPUT="${SCRIPT}.install"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${PROJECT_SOURCE_DIR}" -P ${PROJECT_SOURCE_DIR}/CMakeModules/gitscript.cmake
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.in2 ${PROJECT_SOURCE_DIR}/CMakeModules/gitscript.cmake
    COMMENT "Generating ${SCRIPT}")
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT}.install)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.install RENAME ${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
  # use the source script for man and rst as the version string gets removed
  if (BUILD_MANPAGES)
    add_custom_command(OUTPUT ${SCRIPT}.man
      COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT} --format groff --out ${SCRIPT}.man
      COMMENT "Building ${SCRIPT} manpage"
      DEPENDS VOTCA::votca_help2doc)
    add_custom_target(${SCRIPT}_manpage DEPENDS ${SCRIPT}.man ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT})
    add_dependencies(manpages ${SCRIPT}_manpage)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME ${SCRIPT}.1)
  endif()
  if(SPHINX_FOUND)
    add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/xtp/${SCRIPT}.rst
      COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT} --format rst --out ${VOTCA_SPHINX_DIR}/xtp/${SCRIPT}.rst
      COMMENT "Building ${SCRIPT} rst doc"
      DEPENDS VOTCA::votca_help2doc ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT})
    list(APPEND TOOLS_RST_FILES ${VOTCA_SPHINX_DIR}/xtp/${SCRIPT}.rst)
    string(REGEX REPLACE "." "^" _SCRIPT_UNDERLINE "${SCRIPT}")
    file(APPEND ${XTP_REFERENCE} "${SCRIPT}\n${_SCRIPT_UNDERLINE}\n\n.. include:: ${SCRIPT}.rst\n\n")
  endif()
endforeach(SCRIPT)

if(SPHINX_FOUND)
  add_custom_target(xtp-scripts-rst DEPENDS ${TOOLS_RST_FILES})
  add_dependencies(sphinx-deps xtp-scripts-rst)
endif()

=== xtp/src/CMakeLists.txt ===
add_subdirectory(libxtp)
add_subdirectory(tools)
add_subdirectory(tests)
add_subdirectory(pyxtp)

=== csg/share/template/CMakeLists.txt ===
foreach(PROG template_serial template_threaded)
  file(GLOB ${PROG}_SOURCES ${PROG}.cc)
  add_executable(${PROG} ${${PROG}_SOURCES})
  target_link_libraries(${PROG} votca_csg)
  install(FILES ${${PROG}_SOURCES} DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/template)
 
  add_test(${PROG}Help ${PROG} --help)
endforeach(PROG)

install(FILES CMakeLists.txt.template DESTINATION ${CMAKE_INSTALL_DATADIR}/votca/template RENAME CMakeLists.txt)

=== csg/src/csg_boltzmann/CMakeLists.txt ===
file(GLOB CSG_BO_LIB_SOURCES *.cc)
file(GLOB CSG_BO_MAIN_SOURCES main.cc)
list(REMOVE_ITEM CSG_BO_LIB_SOURCES ${CSG_BO_MAIN_SOURCES})

add_library(votca_csg_boltzmann OBJECT ${CSG_BO_LIB_SOURCES})
target_link_libraries(votca_csg_boltzmann votca_csg)

add_executable(csg_boltzmann ${CSG_BO_MAIN_SOURCES})
target_link_libraries(csg_boltzmann votca_csg_boltzmann votca_csg)
install(TARGETS csg_boltzmann EXPORT VOTCA_CSG_Targets RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
set_property(TARGET votca_csg APPEND PROPERTY BINARIES "csg_boltzmann")
add_executable(VOTCA::csg_boltzmann ALIAS csg_boltzmann)

if (BUILD_MANPAGES)
  add_custom_command(OUTPUT csg_boltzmann.man
    COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name $<TARGET_FILE:VOTCA::csg_boltzmann> --format groff --out csg_boltzmann.man
    COMMENT "Building csg_boltzmann manpage"
    DEPENDS VOTCA::votca_help2doc csg_boltzmann)
  add_custom_target(csg_boltzmann_manpage DEPENDS csg_boltzmann.man)
  add_dependencies(manpages csg_boltzmann_manpage)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/csg_boltzmann.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME csg_boltzmann.1)
endif()

if(SPHINX_FOUND)
  add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/csg/csg_boltzmann.rst
    COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name $<TARGET_FILE:VOTCA::csg_boltzmann> --format rst --out ${VOTCA_SPHINX_DIR}/csg/csg_boltzmann.rst
    COMMENT "Building csg_boltzmann rst doc"
    DEPENDS VOTCA::votca_help2doc csg_boltzmann)
  add_custom_target(csg-boltzmann-rst DEPENDS ${VOTCA_SPHINX_DIR}/csg/csg_boltzmann.rst)
  add_dependencies(sphinx-deps csg-boltzmann-rst)
endif()

=== csg/src/csgapps/CMakeLists.txt ===
option(INSTALL_CSGAPPS "Build csgapps" OFF)
add_feature_info(INSTALL_CSGAPPS INSTALL_CSGAPPS "Install extra app using csg")

file(GLOB FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.cc)
foreach(DIR ${FILES})
  get_filename_component(DIR "${DIR}" DIRECTORY)
  list(APPEND DIRS ${DIR})
endforeach(DIR)
list(REMOVE_DUPLICATES DIRS)
set(CSG_RST_FILES)
foreach(DIR ${DIRS})
  file(GLOB SRC ${DIR}/*.cc)
  add_executable(${DIR} ${SRC})
  target_link_libraries(${DIR} VOTCA::votca_csg)
  if (BUILD_MANPAGES)
    add_custom_command(OUTPUT ${DIR}.man
      COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name ${DIR}/csg_${DIR} --format groff --out ${DIR}.man
      COMMENT "Building csg_${DIR} manpage"
      DEPENDS VOTCA::votca_help2doc ${DIR})
    add_custom_target(${DIR}_manpage DEPENDS ${DIR}.man)
    add_dependencies(manpages ${DIR}_manpage)
  endif()
  if(SPHINX_FOUND)
    add_custom_command(OUTPUT ${VOTCA_SPHINX_DIR}/csg/csg_${DIR}.rst
      COMMAND $<TARGET_FILE:VOTCA::votca_help2doc> --name ${DIR}/csg_${DIR} --format rst --out ${VOTCA_SPHINX_DIR}/csg/csg_${DIR}.rst
      COMMENT "Building csg_${DIR} rst doc"
      DEPENDS VOTCA::votca_help2doc ${DIR})
    list(APPEND CSG_RST_FILES ${VOTCA_SPHINX_DIR}/csg/csg_${DIR}.rst)
  endif()
  if(INSTALL_CSGAPPS)
    install(TARGETS ${DIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    if(BUILD_MANPAGES)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DIR}.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME csg_${DIR}.1)
    endif()
  endif()
  set_target_properties(${DIR} PROPERTIES OUTPUT_NAME csg_${DIR} RUNTIME_OUTPUT_DIRECTORY ${DIR})
  add_test(${DIR}Help ${DIR}/csg_${DIR} --help)
endforeach(DIR)

if(SPHINX_FOUND)
  add_custom_target(csgapps-rst DEPENDS ${CSG_RST_FILES})
  add_dependencies(sphinx-deps csgapps-rst)
endif()

=== csg/src/libcsg/CMakeLists.txt ===
file(GLOB GMX_SOURCES modules/io/gmx*.cc)

file(GLOB H5MD_SOURCES modules/io/h5md*.cc)

file(GLOB IO_SOURCES modules/io/*.cc)
list(REMOVE_ITEM IO_SOURCES ${GMX_SOURCES} ${NOT_GMX_SOURCES} ${H5MD_SOURCES})

file(GLOB VOTCA_SOURCES *.cc potentialfunctions/*.cc)

add_library(votca_csg ${VOTCA_SOURCES} ${IO_SOURCES})
target_compile_features(votca_csg PUBLIC cxx_std_17)

if (TARGET Gromacs::libgromacs)
  #general to a gmx builds
  target_sources(votca_csg PRIVATE ${GMX_SOURCES})
  target_link_libraries(votca_csg PRIVATE Gromacs::libgromacs)
endif()


find_package(HDF5 COMPONENTS "CXX")
set_package_properties(HDF5 PROPERTIES TYPE RECOMMENDED PURPOSE "Used to read h5md data files")
if(HDF5_FOUND)
  set(H5MD true)
  target_include_directories (votca_csg PRIVATE ${HDF5_INCLUDE_DIRS})
  target_sources(votca_csg PRIVATE ${H5MD_SOURCES})
  target_link_libraries(votca_csg PRIVATE ${HDF5_LIBRARIES})
else(HDF5_FOUND)
  set(H5MD)
endif(HDF5_FOUND)

configure_file(votca_csg_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_csg_config.h)

#CMAKE_CURRENT_BINARY_DIR for votca_csg_config.h
target_include_directories(votca_csg PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/csg/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

set_target_properties(votca_csg PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_csg PUBLIC VOTCA::votca_tools Boost::boost PRIVATE Boost::program_options Boost::system Boost::regex Threads::Threads Eigen3::Eigen)

install(TARGETS votca_csg EXPORT VOTCA_CSG_Targets
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT VOTCA_CSG_Targets FILE VOTCA_CSG_Targets.cmake NAMESPACE VOTCA:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_CSG)

include(CMakePackageConfigHelpers)
write_basic_package_version_file("VOTCA_CSGConfigVersion.cmake" VERSION ${PROJECT_VERSION} COMPATIBILITY ExactVersion)
configure_file(VOTCA_CSGConfig.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_CSGConfig.cmake" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_CSGConfig.cmake" "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_CSGConfigVersion.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_CSG)
add_library(VOTCA::votca_csg ALIAS votca_csg)

=== debian/changelog ===
votca (2023-1build2) noble; urgency=medium

  * No-change rebuild for 64-bit time_t.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 14 Apr 2024 14:44:13 +0100

votca (2023-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Dec 2023 23:15:54 +0100

votca (2023-1) unstable; urgency=medium

  * New upstream release.
    - SONAME bump to 2023.
    - Remove tutorial-spce-py3.patch, resolved upstream.
    - Builds with Boost 1.83.  (Closes: #1056008)

 -- Nicholas Breen <nbreen@debian.org>  Fri, 17 Nov 2023 18:23:36 -0800

votca (2022.1-2) unstable; urgency=medium

  [ Nicholas Breen ]
  * sphinx-7-styles.patch: Build with newer Sphinx >= 7.0.
    (Closes: #1042660)
  * Bump S-V to 4.6.2, no changes required.
  * Override lintian false positive built-using-field-on-arch-all-package.

  [ Debian Janitor ]
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete field Contact from debian/upstream/metadata (already present
    in machine-readable debian/copyright).

 -- Nicholas Breen <nbreen@debian.org>  Sun, 29 Oct 2023 11:59:12 -0700

=== debian/control ===
Source: votca
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Nicholas Breen <nbreen@debian.org>
Build-Depends: bash-completion,
               clang-format,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               gromacs (>= 2022),
               libboost-all-dev,
               libecpint-dev,
               libeigen3-dev,
               libexpat-dev,
               libfftw3-dev,
               libgromacs-dev (>= 2022),
               libgsl-dev,
               libhdf5-dev,
               libint2-dev,
               librdkit-dev,
               libsqlite3-dev,
               libxc-dev,
               pkg-config,
               pybind11-dev,
               python3-h5py,
               python3-lxml,
               python3-numpy,
               python3-pytest,
               python3-rdkit,
               python3:any,
               sphinx-common,
               txt2tags
Build-Depends-Indep: doxygen,
                     gnuplot-nox | gnuplot,
                     graphviz,
                     pandoc,
                     python3-ipykernel,
                     python3-nbsphinx,
                     python3-recommonmark,
                     python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.votca.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/votca
Vcs-Git: https://salsa.debian.org/debichem-team/votca.git

Package: libvotca-dev
Section: libdevel
Architecture: any
Depends: libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libvotca-2023 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libvotca-csg-dev (<< 2022~),
        libvotca-tools-dev (<< 2022~),
        libvotca-xtp-dev (<< 2022~)
Replaces: libvotca-csg-dev (<< 2022~),
          libvotca-tools-dev (<< 2022~),
          libvotca-xtp-dev (<< 2022~)
Provides: libvotca-csg-dev, libvotca-tools-dev, libvotca-xtp-dev
Description: VOTCA molecular dynamics analysis - development files
 Versatile Object-Oriented Toolkit for Coarse-Graining Applications (VOTCA)
 is a modeling package for the analysis of molecular dynamics data, the
 development of systematic coarse-graining techniques, and methods used for
 simulating microscopic charge transport in disordered semiconductors.
 .
 This package contains header files and pkg-config files and templates
 for VOTCA programs.

Package: libvotca-2023
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: VOTCA molecular dynamics analysis - shared libraries
 Versatile Object-Oriented Toolkit for Coarse-Graining Applications (VOTCA)
 is a modeling package for the analysis of molecular dynamics data, the
 development of systematic coarse-graining techniques, and methods used for
 simulating microscopic charge transport in disordered semiconductors.
 .
 libvotca contains VOTCA's coarse-graining and excitation transport
 libraries.

Package: votca-data
Architecture: all
Built-Using: ${sphinxdoc:Built-Using}
Depends: bash (>= 4), ${misc:Depends}
Recommends: perl, python3:any, ${perl:Depends}, ${sphinxdoc:Depends}
Breaks: votca-csg-scripts (<< 2022~), votca-xtp (<< 2022~)
Replaces: votca-csg-scripts (<< 2022~), votca-xtp (<< 2022~)
Provides: votca-csg-scripts
Description: VOTCA molecular dynamics analysis - basis sets and scripts
 Versatile Object-Oriented Toolkit for Coarse-Graining Applications (VOTCA)
 is a modeling package for the analysis of molecular dynamics data, the
 development of systematic coarse-graining techniques, and methods used for
 simulating microscopic charge transport in disordered semiconductors.
 .
 This package contains architecture independent coarse-graining scripts
 and basis sets.

Package: votca-tutorials
Architecture: all
Multi-Arch: foreign
Depends: bash (>= 4), ${misc:Depends}, ${python3:Depends}
Recommends: python3:any
Breaks: votca-csg-tutorials (<< 2022~), votca-xtp-tutorials (<< 2022~)
Replaces: votca-csg-tutorials (<< 2022~), votca-xtp-tutorials (<< 2022~)
Provides: votca-csg-tutorials, votca-xtp-tutorials
Description: VOTCA molecular dynamics analysis - tutorials
 Versatile Object-Oriented Toolkit for Coarse-Graining Applications (VOTCA)
 is a modeling package for the analysis of molecular dynamics data, the
 development of systematic coarse-graining techniques, and methods used for
 simulating microscopic charge transport in disordered semiconductors.
 .
 This package contains architecture independent tutorials.

Package: votca
Architecture: any
Depends: votca-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: python3:any
Suggests: votca-tutorials
Breaks: votca-csg (<< 2022~), votca-tools (<< 2022~), votca-xtp (<< 2022~)
Replaces: votca-csg (<< 2022~), votca-tools (<< 2022~), votca-xtp (<< 2022~)
Provides: votca-csg, votca-tools, votca-xtp
Description: Molecular dynamics analysis - coarse-graining and charge transport
 Versatile Object-Oriented Toolkit for Coarse-Graining Applications (VOTCA)
 is a modeling package for the analysis of molecular dynamics data, the
 development of systematic coarse-graining techniques, and methods used for
 simulating microscopic charge transport in disordered semiconductors.
 .
 Numerous molecular dynamics packages, including but not limited to
 GROMACS, ESPREesSo, and LAMPPS, can be used together with VOTCA.
 .
 This package contains user programs for the coarse-graining toolkit (CSG)
 and excitation transport toolkit (XTP).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export CTEST_OUTPUT_ON_FAILURE = On
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Decide whether to build tests.
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	export CONFIG_BUILD_TESTS = -DBUILD_TESTING=TRUE  -DENABLE_REGRESSION_TESTING=TRUE
else
	export CONFIG_BUILD_TESTS = -DBUILD_TESTING=FALSE -DENABLE_REGRESSION_TESTING=FALSE
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_XTP=TRUE \
	-DINSTALL_CSGAPPS=TRUE \
	-DINJECT_MARCH_NATIVE=FALSE \
	$(CONFIG_BUILD_TESTS)
	# Override various blhc false positives.
#	@echo 'blhc: ignore-line-regexp: .*Looking for c\+\+ gmx_.*'
	@echo 'blhc: ignore-line-regexp: .*C\+\+ vector data structures.*'

override_dh_auto_build-indep:
	dh_auto_build
	# temporarily use bundled copy of cma to build documentation - not yet packaged separately
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR)/debian/cma-3.2.0 \
	make -C $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) sphinx
endif

override_dh_installdocs:
	mkdir -p $(CURDIR)/debian/tmp/usr/share/doc/votca/html
	-test -d $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/sphinx.html && \
	cp -aru $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/sphinx.html/* $(CURDIR)/debian/tmp/usr/share/doc/votca/html/
	dh_installdocs
	dh_link -i

override_dh_auto_clean:
	dh_auto_clean
	py3clean $(CURDIR)
	rm -rf $(CURDIR)/.pytest_cache

%:
	dh $@ --with bash-completion,python3,sphinxdoc
